import React from 'react'
import { connect } from 'react-redux'
import styled from 'styled-components'
import { Icon, th } from '@pubsweet/ui'
import { compose, withHandlers } from 'recompose'

import { getSignedUrl } from '../../redux/files'

const FilePreview = ({ previewFile }) => (
  <IconButton onClick={previewFile}>
    <Icon primary size={3}>
      eye
    </Icon>
  </IconButton>
)

export default compose(
  connect(null, { getSignedUrl }),
  withHandlers({
    previewFile: ({ fileId, getSignedUrl }) => e => {
      e.preventDefault()
      const windowReference = window.open()
      getSignedUrl(fileId).then(({ signedUrl }) => {
        windowReference.location = signedUrl
      })
    },
  }),
)(FilePreview)

// #region styled-components
const IconButton = styled.div`
  align-items: center;
  cursor: pointer;
  display: flex;
  justify-content: center;
  margin: 0 ${th('subGridUnit')};
  &:hover {
    opacity: 0.7;
  }
`
// #endregion
